
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Tomcat主配置文件Server.xml详解 / 憋错料</title>

    <meta name="description" content="Tomcat主配置文件Server.xml详解 Tomcat主配置文件Server.xml详解 1.软件版本 [[email protected] META-INF]# java -version java version &quot;1.8.0_60&quot; Java(TM) SE Runtime Environment (build 1.8.0_60-b27) Java HotSpot(TM) 64-Bit Server VM (build 25.60-b23, mixed mode) 2.server.xml组件类别 顶级组件:位于 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Tomcat主配置文件Server.xml详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>Tomcat主配置文件Server.xml详解</h3>
<p><strong>1.软件版本</strong></p>
<pre>[[email&#160;protected]&nbsp;META-INF]#&nbsp;java&nbsp;-version
java&nbsp;version&nbsp;"1.8.0_60"
Java(TM)&nbsp;SE&nbsp;Runtime&nbsp;Environment&nbsp;(build&nbsp;1.8.0_60-b27)
Java&nbsp;HotSpot(TM)&nbsp;64-Bit&nbsp;Server&nbsp;VM&nbsp;(build&nbsp;25.60-b23,&nbsp;mixed&nbsp;mode)</pre>
<h4>2.server.xml组件类别</h4>
<ul>
<li>顶级组件：位于整个配置的顶层，如server。</li>
<li>容器类组件：可以包含其它组件的组件，如service、engine、host、context。</li>
<li>连接器组件：连接用户请求至tomcat，如connector。</li>
<li>被嵌套类组件：位于一个容器当中，不能包含其他组件，如Valve、logger。</li>
</ul>
<h4>3 组件详解</h4>
<ul>
<li>
<pre>engine：核心容器组件，catalina引擎，负责通过connector接收用户请求，并处理请求，将请求转至对应的虚拟主机host。
host：类似于httpd中的虚拟主机，一般而言支持基于FQDN的虚拟主机。
context：定义一个应用程序，是一个最内层的容器类组件（不能再嵌套）。配置context的主要目的指定对应对的webapp的根目录，类似于httpd的alias，其还能为webapp指定额外的属性，如部署方式等。
connector：接收用户请求，类似于httpd的listen配置监听端口的。
service（服务）：将connector关联至engine，因此一个service内部可以有多个connector，但只能有一个引擎engine。service内部有两个connector，一个engine。因此，一般情况下一个server内部只有一个service，一个service内部只有一个engine，但一个service内部可以有多个connector。
server：表示一个运行于JVM中的tomcat实例。
Valve：阀门，拦截请求并在将其转至对应的webapp前进行某种处理操作，可以用于任何容器中，比如记录日志(access&nbsp;log&nbsp;valve)、基于IP做访问控制(remote&nbsp;address&nbsp;filter&nbsp;valve)。
logger：日志记录器，用于记录组件内部的状态信息，可以用于除context外的任何容器中。
realm：可以用于任意容器类的组件中，关联一个用户认证库，实现认证和授权。可以关联的认证库有两种：UserDatabaseRealm、MemoryRealm和JDBCRealm。
UserDatabaseRealm：使用JNDI自定义的用户认证库。
MemoryRealm：认证信息定义在tomcat-users.xml中。
JDBCRealm：认证信息定义在数据库中，并通过JDBC连接至数据库中查找认证用户</pre>
</li>
</ul>
<h4>4 配置文件注释</h4>
<ol>
<li>
<pre>&lt;?xml&nbsp;version=‘1.0‘&nbsp;encoding=‘utf-8‘?&gt;
&lt;!--
&lt;Server&gt;元素代表整个容器,是Tomcat实例的顶层元素.由org.apache.catalina.Server接口来定义.它包含一个&lt;Service&gt;元素.并且它不能做为任何元素的子元素.
&nbsp;&nbsp;&nbsp;&nbsp;port指定Tomcat监听shutdown命令端口.终止服务器运行时,必须在Tomcat服务器所在的机器上发出shutdown命令.该属性是必须的.
&nbsp;&nbsp;&nbsp;&nbsp;shutdown指定终止Tomcat服务器运行时,发给Tomcat服务器的shutdown监听端口的字符串.该属性必须设置
--&gt;
&lt;Server&nbsp;port="8005"&nbsp;shutdown="SHUTDOWN"&gt;
&nbsp;&nbsp;&lt;Listener&nbsp;className="org.apache.catalina.startup.VersionLoggerListener"&nbsp;/&gt;
&nbsp;&nbsp;&lt;Listener&nbsp;className="org.apache.catalina.core.AprLifecycleListener"&nbsp;SSLEngine="on"&nbsp;/&gt;
&nbsp;&nbsp;&lt;Listener&nbsp;className="org.apache.catalina.core.JreMemoryLeakPreventionListener"&nbsp;/&gt;
&nbsp;&nbsp;&lt;Listener&nbsp;className="org.apache.catalina.mbeans.GlobalResourcesLifecycleListener"&nbsp;/&gt;
&nbsp;&nbsp;&lt;Listener&nbsp;className="org.apache.catalina.core.ThreadLocalLeakPreventionListener"&nbsp;/&gt;
&nbsp;&nbsp;&lt;GlobalNamingResources&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;Resource&nbsp;name="UserDatabase"&nbsp;auth="Container"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;type="org.apache.catalina.UserDatabase"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;description="User&nbsp;database&nbsp;that&nbsp;can&nbsp;be&nbsp;updated&nbsp;and&nbsp;saved"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;factory="org.apache.catalina.users.MemoryUserDatabaseFactory"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;pathname="conf/tomcat-users.xml"&nbsp;/&gt;
&nbsp;&nbsp;&lt;/GlobalNamingResources&gt;
&nbsp;&nbsp;&lt;!--service服务组件--&gt;
&nbsp;&nbsp;&lt;Service&nbsp;name="Catalina"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;!--
&nbsp;&nbsp;&nbsp;&nbsp;connector：接收用户请求，类似于httpd的listen配置监听端口.
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;port指定服务器端要创建的端口号，并在这个端口监听来自客户端的请求。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;address：指定连接器监听的地址，默认为所有地址（即0.0.0.0）
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;protocol连接器使用的协议，支持HTTP和AJP。AJP（Apache&nbsp;Jserv&nbsp;Protocol）专用于tomcat与apache建立通信的，&nbsp;在httpd反向代理用户请求至tomcat时使用（可见Nginx反向代理时不可用AJP协议）。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;minProcessors服务器启动时创建的处理请求的线程数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maxProcessors最大可以创建的处理请求的线程数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;enableLookups如果为true，则可以通过调用request.getRemoteHost()进行DNS查询来得到远程客户端的实际主机名，若为false则不进行DNS查询，而是返回其ip地址
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;redirectPort指定服务器正在处理http请求时收到了一个SSL传输请求后重定向的端口号
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;acceptCount指定当所有可以使用的处理请求的线程数都被使用时，可以放到处理队列中的请求数，超过这个数的请求将不予处理
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;connectionTimeout指定超时的时间数(以毫秒为单位)
&nbsp;&nbsp;&nbsp;&nbsp;--&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;Connector&nbsp;port="8080"&nbsp;protocol="HTTP/1.1"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;connectionTimeout="20000"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;redirectPort="8443"&nbsp;/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;Connector&nbsp;port="8009"&nbsp;protocol="AJP/1.3"&nbsp;redirectPort="8443"&nbsp;/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;!--engine,核心容器组件,catalina引擎,负责通过connector接收用户请求,并处理请求,将请求转至对应的虚拟主机host
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;defaultHost指定缺省的处理请求的主机名，它至少与其中的一个host元素的name属性值是一样的
&nbsp;&nbsp;&nbsp;&nbsp;--&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;Engine&nbsp;name="Catalina"&nbsp;defaultHost="localhost"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;!--Realm表示存放用户名，密码及role的数据库--&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Realm&nbsp;className="org.apache.catalina.realm.LockOutRealm"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Realm&nbsp;className="org.apache.catalina.realm.UserDatabaseRealm"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;resourceName="UserDatabase"/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/Realm&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;!--
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;host表示一个虚拟主机
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name指定主机名
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;appBase应用程序基本目录，即存放应用程序的目录.一般为appBase="webapps"&nbsp;，相对于CATALINA_HOME而言的，也可以写绝对路径。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;unpackWARs如果为true，则tomcat会自动将WAR文件解压，否则不解压，直接从WAR文件中运行应用程序
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;autoDeploy：在tomcat启动时，是否自动部署。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xmlValidation：是否启动xml的校验功能，一般xmlValidation="false"。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xmlNamespaceAware：检测名称空间，一般xmlNamespaceAware="false"。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Host&nbsp;name="localhost"&nbsp;&nbsp;appBase="webapps"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;unpackWARs="true"&nbsp;autoDeploy="true"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;!--
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Context表示一个web应用程序，通常为WAR文件
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;docBase应用程序的路径或者是WAR文件存放的路径,也可以使用相对路径，起始路径为此Context所属Host中appBase定义的路径。
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;path表示此web应用程序的url的前缀，这样请求的url为http://localhost:8080/path/****
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;reloadable这个属性非常重要，如果为true，则tomcat会自动检测应用程序的/WEB-INF/lib&nbsp;和/WEB-INF/classes目录的变化，自动装载新的应用程序，可以在不重启tomcat的情况下改变应用程序
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Context&nbsp;path=""&nbsp;docBase=""&nbsp;debug=""/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Valve&nbsp;className="org.apache.catalina.valves.AccessLogValve"&nbsp;directory="logs"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;prefix="localhost_access_log"&nbsp;suffix=".txt"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;pattern="%h&nbsp;%l&nbsp;%u&nbsp;%t&nbsp;&amp;quot;%r&amp;quot;&nbsp;%s&nbsp;%b"&nbsp;/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/Host&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&lt;/Engine&gt;
&nbsp;&nbsp;&lt;/Service&gt;
&lt;/Server&gt;</pre>
</li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 12:01:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/tomcat/" title="tomcat">tomcat</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Tomcat主配置文件Server.xml详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MW8AXl0.html" rel="bookmark">tomcat 的配置文件 server&period;xml 详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server.xml位于$TOMCAT_HOME/conf目录下,作为整个tomcat 服务器最核心的配置文件,server.xml的每一个元素都对应了tomcat中的一个组件,通过对xml中元素的配置,实现对tomcat中的各个组件和端口的配置.通常初学者可以直接使用默认配置即可,但当你本机由于各种原因(如分布式.多IDE等)需要配置多个tomcat时,就需要对server.xml的配置有一定了解. 1. server.xml配置实例 下面是实际开发环境中的tomcat7,端口保持默认,增加了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kyN674.html" rel="bookmark">&lpar;2&rpar; tomcat配置文件server&period;xml详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 入门示例:虚拟主机提供web服务 该示例通过设置虚拟主机来提供web服务,因为是入门示例,所以设置极其简单,只需修改$CATALINA_HOME/conf/server.xml文件为如下内容即可,本文的tomcat安装在/application/tomcat下,因此$CATALINA_HOME=/application/tomcat. 其中大部分都采用了默认设置,只是在engine容器中添加了两个Host容器. &lt;?xml version=&quot;1.0&quot; encoding=&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jL9Z94.html" rel="bookmark">omcat配置文件server&period;xml详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先,看一下tomcat的目录结构: bin            存放启动和关闭tomcat脚本 conf          包含不同的配置文件,server.xml(Tomcat的主要配置文件)和web.xml work          存放jsp编译后产生的class文件 webapp     存放应用程序示例,以后你要部署的应用程序也要放到此目录 logs           存放日志文件 lib/japser/common    这三个目录主要存放tomcat所需的jar文件 ---			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBarRA4.html" rel="bookmark">tomcat配置文件server&period;xml详解 转载http&colon;&sol;&sol;blog&period;csdn&period;net&sol;yuanxuegui2008&sol;article&sol;details&sol;6056754</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				元素名 属性 解释 server port 指定一个端口,这个端口负责监听关闭tomcat 的请求 shutdown 指定向端口发送的命令字符串 service name 指定service 的名字 Connector ( 表示客户端和service之间的连接) port 指定服务器端要创建的端口号,并在这个断口监听来自客户端的请求 minProcessors 服务器启动时创建的处理请求的线程数 maxProcessors 最大可以创建的处理请求的线程数 enableLookups 如果为tru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/BMzxbl3.html" rel="bookmark">Tomcat 配置文件 &lpar;server&period;xml&rpar;详解--转载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;!-- Server中的port监听关闭tomcat的请求,shutdown指定向端口发送的命令串--&gt;&lt;Server port=&quot;8005&quot; shutdown=&quot;SHUTDOWN&quot; debug=&quot;0&quot;&gt; &lt;Listener className=&quot;org.apache.catalina.mbeans.ServerLifecycleListener&quot; debug=&quot;0&quot;/&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/V0b7d93.html" rel="bookmark">Tomcat配置文件server&period;xml详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;?xml version='1.0' encoding='utf-8'?&gt; &lt;Server port=&quot;8005&quot; shutdown=&quot;SHUTDOWN&quot;&gt; &lt;Listener className=&quot;org.apache.catalina.startup.VersionLoggerListener&quot; /&gt; &lt;Listener className=&quot;org.apache.catalina.cor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVzOlyM.html" rel="bookmark">JavaEE学习之Maven配置文件pom&period;xml详解&lpar;转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.引言 (本文转载自:http://blog.csdn.net/longeremmy/article/details/9670619) 使用maven有一些时间了,一直没有好好将pom配置文件每个节点的意义好好了解一番.今天突然想来了解下:pom- project object model 项目对象模型.顾名思义,他是用来描述项目信息的,以及构建方式,依赖等.网上有一篇文章写的很详细,这里就借用一下,以备日后使用. 二.详解 1 &lt;project xmlns=&quot;http://maven.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NKbOBM.html" rel="bookmark">tomcat之配置文件server&period;xml综合分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近有两件完全背道而驰的事情同时发生,第一件事情是以SEO业务为主要业务的业者逐渐减少,许多原本是SEO的业者都纷纷转向其他业务,SEO业务反而变成副业.第二件事情是中小企业的SEO需求增加了,并且大多以钱少人累为主.当然这个观察只是片面的资料,不能说是全面SEO的现况,但是至少反应出了一些问题... SEO的业者之所以会纷纷转向其他业务,当然是因为没有足够的客户来支撑,但是奇怪的是近期所接触的中小企业反而是增高了SEO的需求,为何这些需求没能变成SEO业者的客户呢? 因为这些中小企业可能都已经			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Joq6VM.html" rel="bookmark">maven全局配置文件settings&period;xml详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				maven全局配置文件settings.xml详解 https://www.cnblogs.com/jingmoxukong/p/6050172.html?utm_source=gold_browser_extension 各种标签说明,没有&lt;distributionManagement&gt; 原文地址:https://www.cnblogs.com/stono/p/9456886.html			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0YKeN4.html" rel="bookmark" class="title">SMP、NUMA、MPP体系结构介绍</a>
					<div>
						从系统架构来看,目前的商用服务器大体可以分为三类,即对称多处理器结构 (SMP : Symmetric Multi-Processor) ,非一致存储访问结构 (NUMA : Non-Uniform  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41Apg4.html" rel="bookmark" class="title">【java web学习笔记&lpar;2&rpar;】first servlet</a>
					<div>
						src-&gt; new-&gt; servlet 可见,继承自HttpServlet dopost doget分别是post请求和get请求时调用的 import javax.servlet.Ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0aXqPM.html" rel="bookmark" class="title">全排列（next&lowbar;permutation&rpar;</a>
					<div>
						next_permutation函数既可用于非重排列也可用于重排列: #include &lt;bits/stdc++.h&gt;#define MAXN 200000+10#define ll lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGDLB3.html" rel="bookmark" class="title">Powershell-Exchange：获取移动设备列表</a>
					<div>
						适用:exchange 2010 Get-ActiveSyncDeviceClass: Exchange Online Help   https://technet.microsoft.com/zh- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZVGLq3.html" rel="bookmark" class="title">第6章 MVC基本工具</a>
					<div>
						DI容器.单元测试框架.模仿工具 笔记: 1.Ninject条件绑定常用方法: When(predicate) //当predicate结果为true时,实施绑定.(predicate一个lambda ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvEv80.html" rel="bookmark" class="title">Ubuntu git安装和使用</a>
					<div>
						git --version 如果命令找不到就要安装. 2.sudo apt-get install git 安装git 3.git config --global user.name &quot;to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZ5Kk3.html" rel="bookmark" class="title">2016-1-10 组动画学习 动画实例</a>
					<div>
						// // ViewController.m // 车晓迪demo // // Created by Mac on 16/1/11. // Copyright © 2016年 Mac. All rig ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRpYZ0.html" rel="bookmark" class="title">循环-15&period; 统计素数并求和</a>
					<div>
						循环-15. 统计素数并求和(20) 时间限制 400 ms 内存限制 65536 kB 代码长度限制 8000 B 判题程序 Standard 作者 张彤彧(浙江大学) 本题要求统计给定整数M和N区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONVzG0.html" rel="bookmark" class="title">WPF Step By Step 系列-Prism框架在项目中使用</a>
					<div>
						WPF Step By Step 系列-Prism框架在项目中使用 回顾 上一篇,我们介绍了关于控件模板的用法,本节我们将继续说明WPF更加实用的内容,在大型的项目中如何使用Prism框架,并给予Pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7K8q4.html" rel="bookmark" class="title">DNS分离解析</a>
					<div>
						在Internet环境中,许多大型站点(新浪.网易.腾讯.搜狐--)会分别部署多台镜像服务器,不同 地区或不同ISP接入的用户会自动连接到离他们最近的镜像服务器.针对类似这样的需求,对于这些站点的权  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mZVk0.html" rel="bookmark" class="title">python学习笔记之字符串</a>
					<div>
						python中的字符串在C语言中体现为是一个字符数组,每次创建字符串时候需要在内存中开辟一块连续的空,并且一旦需要修改字符串的话,就需要再次开辟空间,万恶的+号每出现一次就会在内从中重新开辟一块空间. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jePbVM.html" rel="bookmark" class="title">为什么objc&lowbar;msgSend必须用汇编实现</a>
					<div>
						译者前言 总是看到有人说用汇编实现objc_msgSend是为了速度快,当然这个不可否认.但是难道没有别的原因?于是就看到了这篇文章,遂翻译之!=.= 我自己的理解就是,用汇编实现,是为了应对不同的“ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLJPP4.html" rel="bookmark" class="title">微软七届MVP桂素伟：移动互联网与职业规划</a>
					<div>
						原文地址:http://student.csdn.net/mcd/topic/163587/955481 2014年10月19日在哈尔滨工业大学举办了CSDN高校俱乐部全国巡讲. 此次邀请到了微软七届 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNajY0.html" rel="bookmark" class="title">【Longest Valid Parentheses】cpp</a>
					<div>
						题目: Given a string containing just the characters '(' and ')', find the length of the longest valid  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDWk60.html" rel="bookmark" class="title">平台客户端日志查看说明</a>
					<div>
						平台客户端日志,记录了本机客户端遇到的错误.比如:客户端登录失败错误.登录后加载数据出错.窗体打开报错.窗体的按钮点击报错等信息.对于我们排查错误,有很大的帮助! 点开客户端文件夹,查找到log的目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQRb1M.html" rel="bookmark" class="title">&lpar;原创&rpar;c&num;学习笔记09--定义类08--浅度和深度复制</a>
					<div>
						9.8  浅度和深度复制 从一个变量到另一个变量按值复制对象,而不是按引用复制对象(即以与结构相同的方式复制)可能非常复杂.因为一个对象可能包含许多其他对象的引用,例如,字段成员等,这将涉及许多繁琐的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdq860.html" rel="bookmark" class="title">ETL学习笔记之概念篇</a>
					<div>
						导读:ETL,Extraction-Transformation-Loading的缩写,即数据抽取(Extract).转换(Transform).装载(Load)的过程,它是构建数据仓库的重要环节.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME1GdXM.html" rel="bookmark" class="title">Invalid CSRF Token &amp;&num;39&semi;null&amp;&num;39&semi; was found on the request parameter &amp;&num;39&semi;&lowbar;csrf&amp;&num;39&semi; or header &amp;&num;39&semi;X-CSRF-TOKEN&amp;&num;39&semi;</a>
					<div>
						Spring Security :HTTP Status 403-Invalid CSRF Token 'null' was found on the request parameter '_csrf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AxN2y3.html" rel="bookmark" class="title">左神02-排序</a>
					<div>
						冒泡排序 O(n^2) 选择排序  O(n^2) 插入排序 O(N) 计数排序 稳定性 -------------------------------------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ea2Qb0.html" rel="bookmark" class="title">三分钟理解&OpenCurlyDoubleQuote;外观模式&rdquo;&mdash;&mdash;设计模式轻松掌握</a>
					<div>
						实际生活中的例子: 现在流行炒股,股民一般都手持好多个股票,而股民每天需要关注手中N个股票的动向,随时针对不同的股票作出不同的决策,这样感觉心好累:于是有的人选择买基金.基金本质上还是炒股票,只不过基 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
